
#ifndef MOBIES_DTDGEN_H
#define MOBIES_DTDGEN_H


namespace DTDGen
{
	typedef pair<__int64, __int64> card_prod;			//cardinality specification: min, max
	typedef pair<Uml::Class, card_prod> class_w_cp;		//class with cardinality prod
	typedef vector<class_w_cp> cwcp_order;				//list of classes with cardinality info

	//sumarizes cardinalities into one cardinality
	card_prod sum_cardinalities(const vector<card_prod> &ccrs);

	//create a vector fo classes with card. info in alphabetical order
	cwcp_order get_cwcp_order(const Uml::Class & parent, bool uxsdi = false);

	//translates a cardinality specification vector to a DTD cardinality string
	string card_to_dtdspec(const class_w_cp& cwcp);

	//generates DTD elements
	void GenerateDTDElement(const Uml::Class &c,  ostream &output);

	//generate DTD attribute list
	void GenerateDTDAttlist(const Uml::Class &c,  ostream &output);

	//generates complete DTD 
	void GenerateDTD(const Uml::Diagram &diagram,  ostream &output);

	//generate XSD attribute list
	void GenerateXMLSchemaAttributes(const Uml::Class &c,  ostream &output, bool uxsdi = false);

	//generates XSD elements
	void GenerateXMLSchemaElement(const Uml::Class &c,  ostream &output, bool uxsdi = false);	

	//generates complete XML Schema 
	void GenerateXMLSchema(const Uml::Diagram &diagram,  ostream &output, bool uxsdi = false);
};

#endif

