/*
 * OCLParser: P a r s e r  H e a d e r 
 *
 * Generated from: .\ocl.g
 *
 * Terence Parr, Russell Quong, Will Cohen, and Hank Dietz: 1989-1998
 * Parr Research Corporation
 * with Purdue University Electrical Engineering
 * with AHPCRC, University of Minnesota
 * ANTLR Version 1.33MR12b
 */

#ifndef OCLParser_h
#define OCLParser_h

#ifndef ANTLR_VERSION
#define ANTLR_VERSION 13312
#endif

#include "AParser.h"


#include "OCLTree.h"
#include "OCLLexer.h"
#include "OCLParserStatic.h"

	#undef DEBUG

	typedef ANTLRCommonToken ANTLRToken;

	#define ADDLINE( newid, node, oldid )	\
{ pResult->m_mapPositions[ newid ] = node->m_mapPositions[ oldid ]; }

	#define INSLINE0( id ) \
{ Position pos; pos.iLine = LT(1)->getLine(); pos.iColumn = -1; mapPositions.insert( PositionMap::value_type( id, pos ) ); }

	#define INSLINE1( id, line ) \
{ Position pos; pos.iLine = line; pos.iColumn = -1; mapPositions.insert( PositionMap::value_type( id, pos ) ); }

	#pragma warning( disable : 4102 )

	#define IF_NO_EXC( expr ) \
if ( m_ExceptionPool.IsEmpty() ) { \
	expr \
}

	#define IF_EXC_NODE( node ) \
if ( ! m_ExceptionPool.IsEmpty() && node ) { \
	delete node;	\
	node = NULL;	\
}

	#define IF_EXC_NODES( nodes ) \
{	\
	if ( ! m_ExceptionPool.IsEmpty() ) { \
		for ( int iiii = 0 ; iiii < nodes.size() ; iiii++ )	\
		if ( nodes[ iiii ] )	\
		delete nodes[ iiii ];	\
		nodes.clear();	\
	}	\
}
class OCLParser : public ANTLRParser {
public:
	static  const ANTLRChar *tokenName(int tk);
protected:
	static  ANTLRChar *_token_tbl[];
private:

private :
OclTree::TreeManager* 			m_pManager;
OCLLexer* 						m_pLexer;
OclCommon::ExceptionPool		m_ExceptionPool;
bool	 							m_bOnlyContext;

public :
static OclTree::Constraint* ParseConstraint( OclTree::TreeManager* pManager, const GOCL_STL_NS()string& strConstraintArg, bool bOnlyContext, OclCommon::ExceptionPool& ePool )
{
	InitializeTokenSets();
	GOCL_STL_NS()string strConstraint( strConstraintArg );
	DLGStringInput input( ( const DLGChar* ) strConstraint.c_str() );
	OCLLexer lexer( &input );
	ANTLRTokenBuffer pipe( &lexer );
	_ANTLRTokenPtr token = new ANTLRToken;
	lexer.setToken( token );
	OCLParser parser( &pipe );
	
				parser.m_pManager = pManager;
	parser.m_pLexer = &lexer;
	parser.m_ExceptionPool.Clear();
	parser.init();
	
				int iParseSignal;
	OclTree::Constraint* pConstraint = NULL;
	parser.m_bOnlyContext = bOnlyContext;
	parser.constraint( &iParseSignal, pConstraint );
	
				ePool = parser.m_ExceptionPool;
	return pConstraint;
}

private :
GOCL_STL_NS()string Consume( const TokenSet& setTokens, bool bFirstIdentifierUnused )
{
	if ( setTokens.empty() )
	return "";
	bool bConsumeIt = true;
	GOCL_STL_NS()string strConsumed("");
	while ( bConsumeIt ) {
		ANTLRTokenType iCurrent = LA(1);
		GOCL_STL_NS()string strCurrent = GOCL_STL_NS()string( LT(1)->getText() );
		if ( bFirstIdentifierUnused && iCurrent == IDENTIFIER )
		iCurrent = UNUSED;
		bFirstIdentifierUnused = false;
		if ( iCurrent == INPUTEND )
		return strConsumed;
		for ( TokenSet::iterator i = setTokens.begin() ; i != setTokens.end() && bConsumeIt; i++ )
		switch ( *i ) {
			case CLASS_MULTIPLICATIVE :	if ( set_el( iCurrent, MULTIPLICATIVE_OPERATORS_set ) ) bConsumeIt = false; break;
			case CLASS_ADDITIVE :		  	if ( set_el( iCurrent, ADDITIVE_OPERATORS_set ) ) bConsumeIt = false; break;
			case CLASS_RELATIONAL :		if ( set_el( iCurrent, RELATIONAL_OPERATORS_set ) ) bConsumeIt = false; break;
			case CLASS_PREPOST :			if ( set_el( iCurrent, PREPOST_set ) ) bConsumeIt = false; break;
			case CLASS_UNARY :			if ( set_el( iCurrent, UNARY_OPERATORS_set ) ) bConsumeIt = false; break;
			case CLASS_BOOLEAN :			if ( set_el( iCurrent, BOOLEAN_set ) ) bConsumeIt = false; break;
			case CLASS_LOGICAL :			if ( set_el( iCurrent, LOGICAL_OPERATORS_set ) ) bConsumeIt = false; break;
			case CLASS_STEREOTYPES :	if ( set_el( iCurrent, STEREOTYPES_set ) ) bConsumeIt = false; break;
			case CLASS_CALLKIND :			if ( set_el( iCurrent, CALL_OPERATORS_set ) ) bConsumeIt = false; break;
			default : 							if ( *i == iCurrent ) bConsumeIt = false; break;
		}
		if ( bConsumeIt ) {
			consume();
			strConsumed += strCurrent + " ";
		}
	}
	return strConsumed;
}

private :
void AddException( const GOCL_STL_NS()string& strMessage, const GOCL_STL_NS()string& strParam1, const GOCL_STL_NS()string& strParam2, int iLine )
{
	m_ExceptionPool.Add( OclCommon::Exception( OclCommon::Exception::ET_SYNTACTIC, strMessage, strParam1, strParam2, iLine ) );
}

private :
void PrintErrorSelection( GOCL_STL_NS()string strViables, const TokenSet& setRequired, const TokenSet& setFollow )
{
	int iLine = LT(1)->getLine();
	int iCurrent = LA(1);
	GOCL_STL_NS()string strToken = ( iCurrent == INPUTEND ) ? "InputEnd" : "\"" + GOCL_STL_NS()string( LT(1)->getText() ) + "\"";
	if ( iCurrent == IDENTIFIER && ! Contains( setRequired, IDENTIFIER ) )
	iCurrent = UNUSED;
	
				GOCL_STL_NS()string strConsumed = Consume( setFollow, iCurrent == UNUSED );
	GOCL_STL_NS()string strMessage;
	if ( iCurrent == INPUTEND )
	strMessage = "At the end of expression ? cannot be parsed";
	else
	strMessage = "At Token [ ? ] ? cannot be parsed.";
	if ( ! strConsumed.empty() )
	strMessage += " Ignored tokens are [ \" " + strConsumed + "\" ].";
	if ( iCurrent == INPUTEND )
	AddException( strMessage, strViables, "", iLine );
	else
	AddException( strMessage, strToken, strViables, iLine );
}

private :
void PrintErrorToken( const int iToken, const TokenSet& setFollow )
{
	int iLine = LT(1)->getLine();
	int iCurrent = LA(1);
	GOCL_STL_NS()string strToken = ( iCurrent == INPUTEND ) ? "InputEnd" : "\"" + GOCL_STL_NS()string( LT(1)->getText() ) + "\"";
	if ( iCurrent == IDENTIFIER && iToken != IDENTIFIER )
	iCurrent = UNUSED;
	
				GOCL_STL_NS()string strViables = PrintToken( iToken, true );
	
				if ( iToken != INPUTEND && Contains( setFollow, iToken ) ) {
		if ( iCurrent == INPUTEND )
		AddException( "? is missing at the end of expression", strViables, "", iLine );
		else
		AddException( "? is missing before Token [ ? ].", strViables, strToken, iLine );
	}
	else {
		GOCL_STL_NS()string strConsumed = Consume( setFollow, iCurrent == UNUSED );
		if ( iToken == INPUTEND )
		AddException( "Superfluous tokens [ \" ?\" ] are ignored at the end of expression.", strConsumed, "", iLine );
		else {
			if ( iCurrent == INPUTEND )
			AddException( "? is missing at the end of expression", strViables, "", iLine );
			else {
				GOCL_STL_NS()string strMessage = "At Token [ ? ] ? cannot be parsed.";
				if ( ! strConsumed.empty() )
				strMessage += " Ignored tokens are [ \" " + strConsumed + "\" ].";
				AddException( strMessage, strToken, strViables, iLine );
			}
		}
	}
}

private :
bool PrintErrorIteration( const GOCL_STL_NS()string& strSeparator, const TokenSet& setFirst, const TokenSet& setFollow )
{
	int iLine = LT(1)->getLine();
	int iCurrent = LA(1);
	GOCL_STL_NS()string strToken = "\"" + GOCL_STL_NS()string( LT(1)->getText() ) + "\"";
	if ( iCurrent == IDENTIFIER && ! Contains( setFirst, IDENTIFIER ) )
	iCurrent = UNUSED;
	
				if ( ! Contains( setFollow, iCurrent ) && Contains( setFirst, iCurrent ) ) {
		if ( iCurrent == INPUTEND )
		AddException( "? is missing at the end of expression.", strSeparator, "", iLine );
		else
		AddException( "? is missing before Token [ ? ].", strSeparator, strToken, iLine );
		return true;
	}
	return false;
}

private :
OclTree::Constraint* CreateConstraint( const GOCL_STL_NS()string& strName, OclTree::ContextNode* pCNode, OclTree::TreeNode* pNode, const PositionMap& mapPositions )
{
	OclTree::Constraint* pResult = m_pManager->CreateConstraint();
	pResult->m_strName = strName;
	pResult->m_pContext = pCNode;
	pResult->m_pExpression = pNode;
	
				pResult->m_mapPositions = mapPositions;
	ADDLINE( LID_NODE_START, pCNode, LID_NODE_START );
	return pResult;
}

private :
OclTree::ContextNode* CreateContext( const GOCL_STL_NS()string& strName, const GOCL_STL_NS()string& strType, const GOCL_STL_NS()string& strStereotype, const PositionMap& mapPositions, const OclCommon::FormalParameterVector& vecParameters = OclCommon::FormalParameterVector(), const GOCL_STL_NS()string& strReturnType = "" )
{
	OclTree::ContextNode* pResult = m_pManager->CreateContext();
	pResult->m_strName = strName;
	pResult->m_strType = strType;
	pResult->m_strStereotype = strStereotype;
	pResult->m_bClassifier = strReturnType.empty();
	pResult->m_vecParameters = vecParameters;
	pResult->m_strReturnType = strReturnType;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::DeclarationNode* CreateDeclaration( const GOCL_STL_NS()string& strName, const GOCL_STL_NS()string& strType, OclTree::TreeNode* pSNode, const PositionMap& mapPositions )
{
	OclTree::DeclarationNode* pResult = m_pManager->CreateDeclaration();
	pResult->m_strName = strName;
	pResult->m_strType = strType;
	pResult->m_pValueNode = pSNode;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::IfThenElseNode* CreateIfThenElse( OclTree::TreeNode* pIfNode, OclTree::TreeNode* pThenNode, OclTree::TreeNode* pElseNode, const PositionMap& mapPositions )
{
	OclTree::IfThenElseNode* pResult = m_pManager->CreateIfThenElse();
	pResult->m_pIfNode = pIfNode;
	pResult->m_pThenNode = pThenNode;
	pResult->m_pElseNode = pElseNode;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::TypeCastNode* CreateTypeCast( OclTree::TreeNode* pThisNode, OclTree::TreeNode* pTypeNode, bool bIsDynamic, const PositionMap& mapPositions )
{
	OclTree::TypeCastNode* pResult = m_pManager->CreateTypeCast();
	pResult->m_pThisNode = pThisNode;
	pResult->m_bIsDynamic = bIsDynamic;
	pResult->m_mapPositions = mapPositions;
	if ( pTypeNode->GetKind() != OclTree::TreeNode::NK_VARIABLE )
	AddException( "OclAsType operator can be used only with a Type.", "", "", pResult->m_mapPositions[ LID_NODE_START ].iLine );
	else
	pResult->m_strType = ( (OclTree::VariableNode*) pTypeNode)->m_strName;
	delete pTypeNode;
	return pResult;
}

private :
OclTree::MethodNode* CreateMethod( const GOCL_STL_NS()string& strCallOperator, const GOCL_STL_NS()string& strName, OclTree::TreeNode* pThisNode, const OclTree::TreeNodeVector& vecArguments, const PositionMap& mapPositions )
{
	OclTree::MethodNode* pResult = m_pManager->CreateMethod();
	pResult->m_strCallOperator = strCallOperator;
	pResult->m_strName = strName;
	pResult->m_vecArguments = vecArguments;
	pResult->m_pThisNode = pThisNode;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::FunctionNode* CreateFunction( const GOCL_STL_NS()string& strName, const OclTree::TreeNodeVector& vecArguments, const PositionMap& mapPositions )
{
	OclTree::FunctionNode* pResult = m_pManager->CreateFunction();
	pResult->m_strName = strName;
	pResult->m_vecArguments = vecArguments;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::OperatorNode* CreateOperator( const GOCL_STL_NS()string& strName, OclTree::TreeNode* pOperand1, OclTree::TreeNode* pOperand2, const PositionMap& mapPositions )
{
	OclTree::OperatorNode* pResult = m_pManager->CreateOperator();
	pResult->m_strName = strName;
	pResult->m_pOperandNode1 = pOperand1;
	pResult->m_pOperandNode2 = pOperand2;
	pResult->m_mapPositions = mapPositions;
	ADDLINE( LID_NODE_START, pOperand1, LID_NODE_START );
	return pResult;
}

private :
OclTree::IteratorNode* CreateIterator( const GOCL_STL_NS()string& strCallOperator, const GOCL_STL_NS()string& strName, OclTree::TreeNode* pThisNode, OclTree::TreeNode* pArgumentNode, const StringVector& vecDeclarators, const GOCL_STL_NS()string& strDeclType, const GOCL_STL_NS()string& strAccName, const GOCL_STL_NS()string& strAccType, OclTree::TreeNode* pAccuNode, const PositionMap& mapPositions )
{
	OclTree::IteratorNode* pResult = m_pManager->CreateIterator();
	pResult->m_strCallOperator = strCallOperator;
	pResult->m_strName = strName;
	pResult->m_pArgumentNode = pArgumentNode;
	pResult->m_pThisNode = pThisNode;
	pResult->m_vecDeclarators = vecDeclarators;
	pResult->m_strDeclType = strDeclType;
	pResult->m_mapPositions = mapPositions;
	pResult->m_strAccuName = strAccName;
	pResult->m_strAccuType = strAccType;
	pResult->m_pAccuNode = pAccuNode;
	if ( ! strAccName.empty() && ! ( strName == "iterate" ) )
	AddException( "Only the generic iterator [ iterate ] can have accumulator!", "", "", pResult->m_mapPositions[ LID_ACCUMULATOR_NAME ].iLine );
	return pResult;
}

private :
OclTree::VariableNode* CreateVariable( const GOCL_STL_NS()string& strName, const PositionMap& mapPositions )
{
	OclTree::VariableNode* pResult = m_pManager->CreateVariable();
	pResult->m_strName = strName;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::AttributeNode* CreateAttribute( const GOCL_STL_NS()string& strCallOperator, const GOCL_STL_NS()string& strName, OclTree::TreeNode* pThisNode, const PositionMap& mapPositions )
{
	OclTree::AttributeNode* pResult = m_pManager->CreateAttribute();
	pResult->m_strName = strName;
	pResult->m_pThisNode = pThisNode;
	pResult->m_strCallOperator = strCallOperator;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::AssociationNode* CreateAssociation( const GOCL_STL_NS()string& strCallOperator, const GOCL_STL_NS()string& strName, OclTree::TreeNode* pThisNode, const GOCL_STL_NS()string& strAcceptable, const PositionMap& mapPositions )
{
	OclTree::AssociationNode* pResult = m_pManager->CreateAssociation();
	pResult->m_strName = strName;
	pResult->m_pThisNode = pThisNode;
	pResult->m_strCallOperator = strCallOperator;
	pResult->m_strAcceptable = strAcceptable;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
void SetThisForFeature( OclTree::TreeNode*& pResult, OclTree::TreeNode* pThisNode, int iCallOperatorLine )
{
	if ( pResult ) {
		switch ( pResult->GetKind() ) {
			case OclTree::TreeNode::NK_ATTRIBUTE : {
				OclTree::AttributeNode* pCasted = ( OclTree::AttributeNode* ) pResult;
				pCasted->m_pThisNode = pThisNode;
				break;
			}
			case OclTree::TreeNode::NK_ASSOCIATION : {
				OclTree::AssociationNode* pCasted = ( OclTree::AssociationNode* ) pResult;
				pCasted->m_pThisNode = pThisNode;
				break;
			}
			case OclTree::TreeNode::NK_METHOD : {
				OclTree::MethodNode* pCasted = ( OclTree::MethodNode* ) pResult;
				pCasted->m_pThisNode = pThisNode;
				break;
			}
			case OclTree::TreeNode::NK_ITERATOR : {
				OclTree::IteratorNode* pCasted = ( OclTree::IteratorNode* ) pResult;
				pCasted->m_pThisNode = pThisNode;
				break;
			}
			case OclTree::TreeNode::NK_TYPECAST : {
				OclTree::TypeCastNode* pCasted = ( OclTree::TypeCastNode* ) pResult;
				pCasted->m_pThisNode = pThisNode;
				break;
			}
		}
		Position pos; pos.iLine = iCallOperatorLine; pos.iColumn = -1;
		pResult->m_mapPositions[ LID_CALL_OPERATOR ] = pos;
		if ( pThisNode )
		ADDLINE( LID_NODE_START, pThisNode, LID_NODE_START );
	}
}

private :
OclTree::ObjectNode* CreateObject( const GOCL_STL_NS()string& strType, const GOCL_STL_NS()string& strValue, bool bCallable, const PositionMap& mapPositions )
{
	OclTree::ObjectNode* pResult = m_pManager->CreateObject();
	pResult->m_strType = strType;
	pResult->m_strValue = strValue;
	pResult->m_bCallable = bCallable;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}

private :
OclTree::CollectionNode* CreateCollection( const GOCL_STL_NS()string& strType, const OclTree::TreeNodeVector& vecElements, const PositionMap& mapPositions )
{
	OclTree::CollectionNode* pResult = m_pManager->CreateCollection();
	pResult->m_strType = strType;
	pResult->m_vecNodes = vecElements;
	pResult->m_mapPositions = mapPositions;
	return pResult;
}
	static SetWordType setwd1[82];
	static SetWordType setwd2[82];
	static SetWordType setwd3[82];
	static SetWordType setwd4[82];
	static SetWordType BOOLEAN_set[12];
	static SetWordType setwd5[82];
	static SetWordType setwd6[82];
	static SetWordType setwd7[82];
	static SetWordType setwd8[82];
	static SetWordType PREPOST_set[12];
	static SetWordType setwd9[82];
	static SetWordType LOGICAL_IMPLIES_set[12];
	static SetWordType LOGICAL_OR_set[12];
	static SetWordType LOGICAL_AND_set[12];
	static SetWordType RELATIONAL_OPERATORS_set[12];
	static SetWordType ADDITIVE_OPERATORS_set[12];
	static SetWordType setwd10[82];
	static SetWordType MULTIPLICATIVE_OPERATORS_set[12];
	static SetWordType UNARY_OPERATORS_set[12];
	static SetWordType CALL_OPERATORS_set[12];
	static SetWordType setwd11[82];
	static SetWordType setwd12[82];
private:
	void zzdflthandlers( int _signal, int *_retsignal );

public:
	OCLParser(ANTLRTokenBuffer *input);
	void rootExpression(int *_retsignal,  OclTree::TreeNode*& pNode  );
	void constraint(int *_retsignal,  OclTree::Constraint*& pConstraint  );
	void contextDeclaration(int *_retsignal,  const TokenSet& setFollow, OclTree::ContextNode*& pCNode  );
	void operationContextTester(int *_retsignal);
	void contextDeclarationHelper(int *_retsignal,  const TokenSet& setFollow, OclTree::ContextNode*& pCNode, PositionMap& mapPositions  );
	void classifierContextWithNameTester(int *_retsignal);
	void classifierContext(int *_retsignal,  const TokenSet& setFollow, OclTree::ContextNode*& pCNode, PositionMap& mapPositions  );
	void operationContext(int *_retsignal,  const TokenSet& setFollow, OclTree::ContextNode*& pCNode, PositionMap& mapPositions  );
	void formalParameterList(int *_retsignal,  const TokenSet& setFollow, OclCommon::FormalParameterVector& vecParameters, PositionMap& mapPositions  );
	void formalParameter(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strName , GOCL_STL_NS()string& strType, PositionMap& mapPositions, int& iPrmCnt  );
	void expression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void letExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::DeclarationNode*& pDNode  );
	void ifExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void implicationExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void implicationExpressionRight(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode, GOCL_STL_NS()string& strOp, PositionMap& mapPositions  );
	void orExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void xorExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void andExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void relationalExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void additiveExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void multiplicativeExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void unaryExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void primaryExpressionTester(int *_retsignal);
	void postfixExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void featureCallWithThis(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode* pSelf, OclTree::TreeNode*& pNode  );
	void primaryExpression(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void featureCall(int *_retsignal,  const TokenSet& setFollow, const GOCL_STL_NS()string& strCallOperator, OclTree::TreeNode*& pNode  );
	void featureCallParameters(int *_retsignal,  const TokenSet& setFollow, const GOCL_STL_NS()string& strName, const GOCL_STL_NS()string& strCallOperator, OclTree::TreeNode*& pNode, PositionMap& mapPositions  );
	void iteratorMethodCallTester(int *_retsignal);
	void featureCallParametersHelper(int *_retsignal,  const TokenSet& setFollow, const GOCL_STL_NS()string& strName, const GOCL_STL_NS()string& strCallOperator, OclTree::TreeNode*& pNode, PositionMap& mapPositions  );
	void iteratorMethodCall(int *_retsignal,  const TokenSet& setFollow, const GOCL_STL_NS()string& strName, const GOCL_STL_NS()string& strCallOperator, OclTree::TreeNode*& pNode, PositionMap& mapPositions  );
	void iteratorDeclaration(int *_retsignal,  const TokenSet& setFollow, StringVector& vecDeclarators, GOCL_STL_NS()string& strDeclType, GOCL_STL_NS()string& strAccName, GOCL_STL_NS()string& strAccType, OclTree::TreeNode*& pAccNode, PositionMap& mapPositions  );
	void actualParameterList(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNodeVector& vecArguments  );
	void qualifiers(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strRole, PositionMap& mapPositions  );
	void literal(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void literalCollection(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNode*& pNode  );
	void expressionListOrRange(int *_retsignal,  const TokenSet& setFollow, OclTree::TreeNodeVector& vecElements  );
	void typeName(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strName  );
	void name(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strName  );
	void wrap_colon(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_doublecolon(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_context(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_inv(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_left_parenthesis(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_right_parenthesis(int *_retsignal,  const TokenSet& setFollow  );
	void prePost(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strStereotypes  );
	void wrap_semicolon(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_let(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_equal(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_in(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_if(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_then(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_else(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_endif(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_implies(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void wrap_or(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void wrap_xor(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_and(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void relationalOperator(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void addOperator(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void multiplyOperator(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void unaryOperator(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strOp  );
	void callOperator(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strCallOperator  );
	void wrap_comma(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_delimiter(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_left_bracket(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_right_bracket(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_left_brace(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_right_brace(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_string(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strValue  );
	void wrap_real(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strValue  );
	void wrap_integer(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strValue  );
	void wrap_pound(int *_retsignal,  const TokenSet& setFollow  );
	void wrap_boolean(int *_retsignal,  const TokenSet& setFollow, GOCL_STL_NS()string& strValue  );
	void wrap_inputend(int *_retsignal);
	static SetWordType STEREOTYPES_set[12];
	static SetWordType LOGICAL_OPERATORS_set[12];
};

#endif /* OCLParser_h */
