#ifndef MOBIES_SIGNALFLOW_H
#define MOBIES_SIGNALFLOW_H
// header file SignalFlow.h generated from diagram SignalFlow
// generated on Thu Sep 16 10:49:57 2004

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif



namespace SignalFlow {

	class  CompoundComponent;
	class  RootFolder;
	class  PrimitiveComponent;
	class  BaseComponent;
	class  Signal;
	class  LocalPort;
	class  BaseSignal;
	class  OutputPort;
	class  InputPort;
	class  PortBase;

	class  Visitor : public Udm::BaseVisitor 
	{
	public:
		virtual void Visit_CompoundComponent(const CompoundComponent&){};
		virtual void Visit_RootFolder(const RootFolder&){};
		virtual void Visit_PrimitiveComponent(const PrimitiveComponent&){};
		virtual void Visit_Signal(const Signal&){};
		virtual void Visit_LocalPort(const LocalPort&){};
		virtual void Visit_OutputPort(const OutputPort&){};
		virtual void Visit_InputPort(const InputPort&){};
		virtual void Visit_Object(const Udm::Object&){};
		virtual ~Visitor(){};
	};

	  void Initialize();

	  void Initialize(const Uml::Diagram &dgr);
	extern  Udm::UdmDiagram diagram;

	class  RootFolder :  public Udm::Object {
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : Object(impl) { }
		RootFolder(const RootFolder &master) : Object(master) { }
		static RootFolder Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		RootFolder CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		RootFolder CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<RootFolder> Instances() { return Udm::InstantiatedAttr<SignalFlow::RootFolder>(impl);}
		template <class Pred> Udm::InstantiatedAttr<RootFolder, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::RootFolder, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::RootFolder> Derived() { return Udm::DerivedAttr<SignalFlow::RootFolder>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::RootFolder, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::RootFolder, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::RootFolder> Archetype() { return Udm::ArchetypeAttr<SignalFlow::RootFolder>(impl);}

		static Uml::CompositionChildRole meta_CompoundComponent_children;
		Udm::ChildrenAttr<SignalFlow::CompoundComponent> CompoundComponent_children() const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent>(impl, meta_CompoundComponent_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred> CompoundComponent_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred>(impl, meta_CompoundComponent_children); }

		Udm::ChildrenAttr<SignalFlow::CompoundComponent> CompoundComponent_kind_children() const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred> CompoundComponent_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::BaseComponent> BaseComponent_kind_children() const { return Udm::ChildrenAttr<SignalFlow::BaseComponent>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred> BaseComponent_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_RootFolder(*this);};
	};

	class  BaseComponent :  public Udm::Object {
	 public:
		static Uml::Class meta;

		BaseComponent() { }
		BaseComponent(Udm::ObjectImpl *impl) : Object(impl) { }
		BaseComponent(const BaseComponent &master) : Object(master) { }
		static BaseComponent Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static BaseComponent Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		BaseComponent CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		BaseComponent CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<BaseComponent> Instances() { return Udm::InstantiatedAttr<SignalFlow::BaseComponent>(impl);}
		template <class Pred> Udm::InstantiatedAttr<BaseComponent, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::BaseComponent, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::BaseComponent> Derived() { return Udm::DerivedAttr<SignalFlow::BaseComponent>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::BaseComponent, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::BaseComponent, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::BaseComponent> Archetype() { return Udm::ArchetypeAttr<SignalFlow::BaseComponent>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_InputPort_children;
		Udm::ChildrenAttr<SignalFlow::InputPort> InputPort_children() const { return Udm::ChildrenAttr<SignalFlow::InputPort>(impl, meta_InputPort_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::InputPort, Pred> InputPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::InputPort, Pred>(impl, meta_InputPort_children); }

		static Uml::CompositionChildRole meta_OutputPort_children;
		Udm::ChildrenAttr<SignalFlow::OutputPort> OutputPort_children() const { return Udm::ChildrenAttr<SignalFlow::OutputPort>(impl, meta_OutputPort_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::OutputPort, Pred> OutputPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::OutputPort, Pred>(impl, meta_OutputPort_children); }

		static Uml::CompositionChildRole meta_BaseSignal_children;
		Udm::ChildrenAttr<SignalFlow::BaseSignal> BaseSignal_children() const { return Udm::ChildrenAttr<SignalFlow::BaseSignal>(impl, meta_BaseSignal_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::BaseSignal, Pred> BaseSignal_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::BaseSignal, Pred>(impl, meta_BaseSignal_children); }

		Udm::ChildrenAttr<SignalFlow::Signal> Signal_kind_children() const { return Udm::ChildrenAttr<SignalFlow::Signal>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::Signal, Pred> Signal_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::Signal, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::BaseSignal> BaseSignal_kind_children() const { return Udm::ChildrenAttr<SignalFlow::BaseSignal>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::BaseSignal, Pred> BaseSignal_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::BaseSignal, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::OutputPort> OutputPort_kind_children() const { return Udm::ChildrenAttr<SignalFlow::OutputPort>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::OutputPort, Pred> OutputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::OutputPort, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::InputPort> InputPort_kind_children() const { return Udm::ChildrenAttr<SignalFlow::InputPort>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::InputPort, Pred> InputPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::InputPort, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::PortBase> PortBase_kind_children() const { return Udm::ChildrenAttr<SignalFlow::PortBase>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::PortBase, Pred> PortBase_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::PortBase, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_CompoundComponent_parent;
		Udm::ParentAttr<SignalFlow::CompoundComponent> CompoundComponent_parent() const { return Udm::ParentAttr<SignalFlow::CompoundComponent>(impl, meta_CompoundComponent_parent); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
	};

	class  CompoundComponent :  public BaseComponent {
	 public:
		static Uml::Class meta;

		CompoundComponent() { }
		CompoundComponent(Udm::ObjectImpl *impl) : BaseComponent(impl) { }
		CompoundComponent(const CompoundComponent &master) : BaseComponent(master) { }
		static CompoundComponent Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static CompoundComponent Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		CompoundComponent CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		CompoundComponent CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<CompoundComponent> Instances() { return Udm::InstantiatedAttr<SignalFlow::CompoundComponent>(impl);}
		template <class Pred> Udm::InstantiatedAttr<CompoundComponent, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::CompoundComponent, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::CompoundComponent> Derived() { return Udm::DerivedAttr<SignalFlow::CompoundComponent>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::CompoundComponent, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::CompoundComponent, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::CompoundComponent> Archetype() { return Udm::ArchetypeAttr<SignalFlow::CompoundComponent>(impl);}

		static Uml::CompositionChildRole meta_LocalPort_children;
		Udm::ChildrenAttr<SignalFlow::LocalPort> LocalPort_children() const { return Udm::ChildrenAttr<SignalFlow::LocalPort>(impl, meta_LocalPort_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::LocalPort, Pred> LocalPort_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::LocalPort, Pred>(impl, meta_LocalPort_children); }

		static Uml::CompositionChildRole meta_BaseComponent_children;
		Udm::ChildrenAttr<SignalFlow::BaseComponent> BaseComponent_children() const { return Udm::ChildrenAttr<SignalFlow::BaseComponent>(impl, meta_BaseComponent_children); }
		 template <class Pred> Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred> BaseComponent_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred>(impl, meta_BaseComponent_children); }

		Udm::ChildrenAttr<SignalFlow::CompoundComponent> CompoundComponent_kind_children() const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred> CompoundComponent_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::CompoundComponent, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::PrimitiveComponent> PrimitiveComponent_kind_children() const { return Udm::ChildrenAttr<SignalFlow::PrimitiveComponent>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::PrimitiveComponent, Pred> PrimitiveComponent_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::PrimitiveComponent, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::BaseComponent> BaseComponent_kind_children() const { return Udm::ChildrenAttr<SignalFlow::BaseComponent>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred> BaseComponent_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::BaseComponent, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::LocalPort> LocalPort_kind_children() const { return Udm::ChildrenAttr<SignalFlow::LocalPort>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::LocalPort, Pred> LocalPort_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::LocalPort, Pred>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<SignalFlow::PortBase> PortBase_kind_children() const { return Udm::ChildrenAttr<SignalFlow::PortBase>(impl, Udm::NULLCHILDROLE); }
		template<class Pred> Udm::ChildrenAttr<SignalFlow::PortBase, Pred> PortBase_kind_children_sorted(const Pred &) const { return Udm::ChildrenAttr<SignalFlow::PortBase, Pred>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<SignalFlow::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<SignalFlow::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_CompoundComponent(*this);};
	};

	class  PrimitiveComponent :  public BaseComponent {
	 public:
		static Uml::Class meta;

		PrimitiveComponent() { }
		PrimitiveComponent(Udm::ObjectImpl *impl) : BaseComponent(impl) { }
		PrimitiveComponent(const PrimitiveComponent &master) : BaseComponent(master) { }
		static PrimitiveComponent Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static PrimitiveComponent Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		PrimitiveComponent CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		PrimitiveComponent CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<PrimitiveComponent> Instances() { return Udm::InstantiatedAttr<SignalFlow::PrimitiveComponent>(impl);}
		template <class Pred> Udm::InstantiatedAttr<PrimitiveComponent, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::PrimitiveComponent, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::PrimitiveComponent> Derived() { return Udm::DerivedAttr<SignalFlow::PrimitiveComponent>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::PrimitiveComponent, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::PrimitiveComponent, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::PrimitiveComponent> Archetype() { return Udm::ArchetypeAttr<SignalFlow::PrimitiveComponent>(impl);}

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_PrimitiveComponent(*this);};
	};

	class  BaseSignal :  public Udm::Object {
	 public:
		static Uml::Class meta;

		BaseSignal() { }
		BaseSignal(Udm::ObjectImpl *impl) : Object(impl) { }
		BaseSignal(const BaseSignal &master) : Object(master) { }
		static BaseSignal Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static BaseSignal Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		BaseSignal CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		BaseSignal CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<BaseSignal> Instances() { return Udm::InstantiatedAttr<SignalFlow::BaseSignal>(impl);}
		template <class Pred> Udm::InstantiatedAttr<BaseSignal, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::BaseSignal, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::BaseSignal> Derived() { return Udm::DerivedAttr<SignalFlow::BaseSignal>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::BaseSignal, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::BaseSignal, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::BaseSignal> Archetype() { return Udm::ArchetypeAttr<SignalFlow::BaseSignal>(impl);}

		static Uml::CompositionParentRole meta_BaseComponent_parent;
		Udm::ParentAttr<SignalFlow::BaseComponent> BaseComponent_parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, meta_BaseComponent_parent); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dst_end_;
		Udm::AssocEndAttr<SignalFlow::PortBase> dst_end() const { return Udm::AssocEndAttr<SignalFlow::PortBase>(impl, meta_dst_end_); }

		static Uml::AssociationRole meta_src_end_;
		Udm::AssocEndAttr<SignalFlow::PortBase> src_end() const { return Udm::AssocEndAttr<SignalFlow::PortBase>(impl, meta_src_end_); }

	};

	class  Signal :  public BaseSignal {
	 public:
		static Uml::Class meta;

		Signal() { }
		Signal(Udm::ObjectImpl *impl) : BaseSignal(impl) { }
		Signal(const Signal &master) : BaseSignal(master) { }
		static Signal Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static Signal Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Signal CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		Signal CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<Signal> Instances() { return Udm::InstantiatedAttr<SignalFlow::Signal>(impl);}
		template <class Pred> Udm::InstantiatedAttr<Signal, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::Signal, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::Signal> Derived() { return Udm::DerivedAttr<SignalFlow::Signal>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::Signal, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::Signal, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::Signal> Archetype() { return Udm::ArchetypeAttr<SignalFlow::Signal>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_Signal(*this);};
	};

	class  PortBase :  public Udm::Object {
	 public:
		static Uml::Class meta;

		PortBase() { }
		PortBase(Udm::ObjectImpl *impl) : Object(impl) { }
		PortBase(const PortBase &master) : Object(master) { }
		static PortBase Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static PortBase Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		PortBase CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		PortBase CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<PortBase> Instances() { return Udm::InstantiatedAttr<SignalFlow::PortBase>(impl);}
		template <class Pred> Udm::InstantiatedAttr<PortBase, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::PortBase, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::PortBase> Derived() { return Udm::DerivedAttr<SignalFlow::PortBase>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::PortBase, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::PortBase, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::PortBase> Archetype() { return Udm::ArchetypeAttr<SignalFlow::PortBase>(impl);}

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::AssociationRole meta_src, meta_src_rev;
		Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase> src() const { return Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase>(impl, meta_src, meta_src_rev); }
		template<class Pred> Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase, Pred> src_sorted(const Pred &) const { return Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase, Pred>(impl, meta_src, meta_src_rev); }

		static Uml::AssociationRole meta_dst, meta_dst_rev;
		Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase> dst() const { return Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase>(impl, meta_dst, meta_dst_rev); }
		template<class Pred> Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase, Pred> dst_sorted(const Pred &) const { return Udm::AClassAssocAttr<SignalFlow::BaseSignal, SignalFlow::PortBase, Pred>(impl, meta_dst, meta_dst_rev); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class  LocalPort :  public PortBase {
	 public:
		static Uml::Class meta;

		LocalPort() { }
		LocalPort(Udm::ObjectImpl *impl) : PortBase(impl) { }
		LocalPort(const LocalPort &master) : PortBase(master) { }
		static LocalPort Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static LocalPort Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		LocalPort CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		LocalPort CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<LocalPort> Instances() { return Udm::InstantiatedAttr<SignalFlow::LocalPort>(impl);}
		template <class Pred> Udm::InstantiatedAttr<LocalPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::LocalPort, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::LocalPort> Derived() { return Udm::DerivedAttr<SignalFlow::LocalPort>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::LocalPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::LocalPort, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::LocalPort> Archetype() { return Udm::ArchetypeAttr<SignalFlow::LocalPort>(impl);}

		static Uml::CompositionParentRole meta_CompoundComponent_parent;
		Udm::ParentAttr<SignalFlow::CompoundComponent> CompoundComponent_parent() const { return Udm::ParentAttr<SignalFlow::CompoundComponent>(impl, meta_CompoundComponent_parent); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_LocalPort(*this);};
	};

	class  OutputPort :  public PortBase {
	 public:
		static Uml::Class meta;

		OutputPort() { }
		OutputPort(Udm::ObjectImpl *impl) : PortBase(impl) { }
		OutputPort(const OutputPort &master) : PortBase(master) { }
		static OutputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static OutputPort Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		OutputPort CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		OutputPort CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<OutputPort> Instances() { return Udm::InstantiatedAttr<SignalFlow::OutputPort>(impl);}
		template <class Pred> Udm::InstantiatedAttr<OutputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::OutputPort, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::OutputPort> Derived() { return Udm::DerivedAttr<SignalFlow::OutputPort>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::OutputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::OutputPort, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::OutputPort> Archetype() { return Udm::ArchetypeAttr<SignalFlow::OutputPort>(impl);}

		static Uml::CompositionParentRole meta_BaseComponent_parent;
		Udm::ParentAttr<SignalFlow::BaseComponent> BaseComponent_parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, meta_BaseComponent_parent); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_OutputPort(*this);};
	};

	class  InputPort :  public PortBase {
	 public:
		static Uml::Class meta;

		InputPort() { }
		InputPort(Udm::ObjectImpl *impl) : PortBase(impl) { }
		InputPort(const InputPort &master) : PortBase(master) { }
		static InputPort Cast(const Udm::Object &a) { return __Cast(a, meta); }

		static InputPort Create(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		InputPort CreateInstance(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl); }

		InputPort CreateDerived(const Udm::Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role, impl, true); }

		Udm::InstantiatedAttr<InputPort> Instances() { return Udm::InstantiatedAttr<SignalFlow::InputPort>(impl);}
		template <class Pred> Udm::InstantiatedAttr<InputPort, Pred> Instances_sorted(const Pred &) { return Udm::InstantiatedAttr<SignalFlow::InputPort, Pred>(impl);}

		Udm::DerivedAttr<SignalFlow::InputPort> Derived() { return Udm::DerivedAttr<SignalFlow::InputPort>(impl);}
		template <class Pred> Udm::DerivedAttr<SignalFlow::InputPort, Pred> Derived_sorted(const Pred &) { return Udm::DerivedAttr<SignalFlow::InputPort, Pred>(impl);}

		Udm::ArchetypeAttr<SignalFlow::InputPort> Archetype() { return Udm::ArchetypeAttr<SignalFlow::InputPort>(impl);}

		static Uml::CompositionParentRole meta_BaseComponent_parent;
		Udm::ParentAttr<SignalFlow::BaseComponent> BaseComponent_parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, meta_BaseComponent_parent); }

		Udm::ParentAttr<SignalFlow::BaseComponent> parent() const { return Udm::ParentAttr<SignalFlow::BaseComponent>(impl, Udm::NULLPARENTROLE); }
		virtual void Accept(Visitor &v){v.Visit_InputPort(*this);};
	};

}

#endif //MOBIES_SIGNALFLOW_H
